package com.jzdsh.util;

import com.aliyuncs.DefaultAcsClient;
import com.aliyuncs.IAcsClient;
import com.aliyuncs.dysmsapi.model.v20170525.SendSmsRequest;
import com.aliyuncs.dysmsapi.model.v20170525.SendSmsResponse;
import com.aliyuncs.exceptions.ClientException;
import com.aliyuncs.profile.DefaultProfile;
import com.aliyuncs.profile.IClientProfile;


public class HttpSender {


    //产品名称:云通信短信API产品,开发者无需替换
    static final String product = "Dysmsapi";
    //产品域名,开发者无需替换
    static final String domain = "dysmsapi.aliyuncs.com";

    // TODO 此处需要替换成开发者自己的AK(在阿里云访问控制台寻找)
/*    static final String accessKeyId = "nI7j7sUzmnm3HIGn";
    static final String accessKeySecret = "1ATZnBIGvT6iWN6IIqryAvnUhE23LP";*/

    static final String accessKeyId = "LTAI4Fs93xFTiBDZZn8cii39";
    static final String accessKeySecret = "f3ARitQdcp5uKasb9bEUqIDHXcufFc";


    //发送短信方法
    public static boolean sendSms(String signname, String templatecode, String phone, String paramstring) {
        try {
            //可自助调整超时时间
            System.setProperty("sun.net.client.defaultConnectTimeout", "10000");
            System.setProperty("sun.net.client.defaultReadTimeout", "10000");

            //初始化acsClient,暂不支持region化
            IClientProfile profile = DefaultProfile.getProfile("cn-hangzhou", accessKeyId, accessKeySecret);
            DefaultProfile.addEndpoint("cn-hangzhou", "cn-hangzhou", product, domain);
            IAcsClient acsClient = new DefaultAcsClient(profile);

            //组装请求对象-具体描述见控制台-文档部分内容
            SendSmsRequest request = new SendSmsRequest( );
            //必填:待发送手机号
            request.setPhoneNumbers(phone);
            //必填:短信签名-可在短信控制台中找到
            request.setSignName(signname);
            //必填:短信模板-可在短信控制台中找到
            request.setTemplateCode(templatecode);
            //可选:模板中的变量替换JSON串,如模板内容为"亲爱的${name},您的验证码为${code}"时,此处的值为
            request.setTemplateParam(paramstring);

            //选填-上行短信扩展码(无特殊需求用户请忽略此字段)
            //request.setSmsUpExtendCode("90997");

            //可选:outId为提供给业务方扩展字段,最终在短信回执消息中将此值带回给调用者
            request.setOutId("yourOutId");

            //hint 此处可能会抛出异常，注意catch

            SendSmsResponse sendSmsResponse = acsClient.getAcsResponse(request);

            System.err.println(sendSmsResponse.getMessage( ));
            if ("OK".equals(sendSmsResponse.getCode( ))) {
                return true;
            } else {
                return false;
            }
        } catch (Exception e) {
            System.err.println("发送短信出错：" + e.getMessage( ));
            e.printStackTrace( );
            return false;
        }
    }

    /**
     * @param accessKeyId     aliyun key         "LTAI4Fs93xFTiBDZZn8cii39"
     * @param accessKeySecret aliyun secret   "f3ARitQdcp5uKasb9bEUqIDHXcufFc"
     * @param signname        短信签名			  "附近养车网"
     * @param templatecode    短信模板 		  String templatecode = "SMS_177547615";
     * @param phone           发送短信的 电话好吗
     * @param paramstring     参数             案列： String paramstring = "{\"code\":\"" + sendCoeds + "\"}";
     * @return
     * @throws ClientException String templatecode = "SMS_177547615";
     *                         String paramstring = "{\"code\":\"" + sendCoeds + "\"}";
     *                         boolean status = HttpSender.aliyunSendSms("LTAI4Fs93xFTiBDZZn8cii39","f3ARitQdcp5uKasb9bEUqIDHXcufFc","附近养车网", "SMS_177547615", phone, paramstring);
     */
    public static boolean aliyunSendSms(String accessKeyId, String accessKeySecret, String signname, String templatecode, String phone, String paramstring) throws ClientException {

        //可自助调整超时时间
        System.setProperty("sun.net.client.defaultConnectTimeout", "10000");
        System.setProperty("sun.net.client.defaultReadTimeout", "10000");

        //初始化acsClient,暂不支持region化
        IClientProfile profile = DefaultProfile.getProfile("cn-hangzhou", accessKeyId, accessKeySecret);
        DefaultProfile.addEndpoint("cn-hangzhou", "cn-hangzhou", product, domain);
        IAcsClient acsClient = new DefaultAcsClient(profile);

        //组装请求对象-具体描述见控制台-文档部分内容
        SendSmsRequest request = new SendSmsRequest( );
        //必填:待发送手机号
        request.setPhoneNumbers(phone);
        //必填:短信签名-可在短信控制台中找到
        request.setSignName(signname);
        //必填:短信模板-可在短信控制台中找到
        request.setTemplateCode(templatecode);
        //可选:模板中的变量替换JSON串,如模板内容为"亲爱的${name},您的验证码为${code}"时,此处的值为
        request.setTemplateParam(paramstring);

        //选填-上行短信扩展码(无特殊需求用户请忽略此字段)
        //request.setSmsUpExtendCode("90997");

        //可选:outId为提供给业务方扩展字段,最终在短信回执消息中将此值带回给调用者
        request.setOutId("yourOutId");

        //hint 此处可能会抛出异常，注意catch
        try {
            SendSmsResponse sendSmsResponse = acsClient.getAcsResponse(request);

            System.err.println(sendSmsResponse.getMessage( ));
            if ("OK".equals(sendSmsResponse.getCode( ))) {
                return true;
            } else {
                return false;
            }
        } catch (Exception e) {
            System.err.println("发送短信出错：" + e.getMessage( ));
            e.printStackTrace( );
            return false;
        }

    }

}
